package za.co.sean.test;

import java.util.HashMap;

import org.docx4j.XmlUtils;
import org.docx4j.openpackaging.packages.WordprocessingMLPackage;
import org.docx4j.openpackaging.parts.WordprocessingML.MainDocumentPart;
import org.docx4j.wml.Document;

public class DocumentTextReplacer {

	private static final String REPLACER_EXCEPTION = "Exception occurred whilst trying to replace merge tags in document : Message : ";
	
	public static void replaceMailMergeTagsWithValues(WordprocessingMLPackage wordMLPackage, String outputFilePath) throws Exception {

		try {
			MainDocumentPart documentPart = wordMLPackage.getMainDocumentPart();
			org.docx4j.wml.Document wmlDocumentEl = (org.docx4j.wml.Document) documentPart.getJaxbElement();
			String xml = XmlUtils.marshaltoString(wmlDocumentEl, true);
			HashMap<String, String> mappings = new HashMap<String, String>();
			mappings.put("SPOUSE", "Your Spouses Name");
			mappings.put("PLANHOLDER", "Sean Nell");
			mappings.put("POLICYNO", "5558978");
			mappings.put("FNBLIFE", "FNBLife Team");
			mappings.put("Child1", "A Child 1");
			mappings.put("Child2", "A Child 2");
			mappings.put("Child3", "");
			mappings.put("Child4", "");
			mappings.put("Child5", "");
			Object obj = XmlUtils.unmarshallFromTemplate(xml, mappings);
			documentPart.setJaxbElement((Document) obj);             
			wordMLPackage.save(new java.io.File(outputFilePath));
		} catch (Exception e) {
			throw new Exception(REPLACER_EXCEPTION + e.getMessage());
		}
	}
}
